--
--  AppDelegate.applescript
--  continityCameraAS
--
--  Created by Takaaki Naganoya on 2019/10/21.
--  Copyright © 2019 Takaaki Naganoya. All rights reserved.
--

script AppDelegate
	property parent : class "NSObject"
	
	-- IBOutlets
	property theWindow : missing value
	property theImageV : missing value
	
	on applicationWillFinishLaunching_(aNotification)
		-- Insert code here to initialize your application before any files are opened 
	end applicationWillFinishLaunching_
	

	on applicationShouldTerminate_(sender)
		-- Insert code here to do any housekeeping before your application quits 
		return current application's NSTerminateNow
	end applicationShouldTerminate_


	on clicked_(aSender)
		set imgRes to theImageV's image()
		set dtPath to POSIX path of (path to desktop)
		log {"dtPath",dtPath}
		set fRes to retUUIDfilePath(dtPath, "png") of me
		log {"fRes",fRes}
		set sRes to saveNSImageAtPathAsPNG(imgRes, fRes) of me
	end clicked_


	--NSImageを指定パスにPNG形式で保存
	on saveNSImageAtPathAsPNG(anImage, outPath)
		set imageRep to anImage's TIFFRepresentation()
		set aRawimg to current application's NSBitmapImageRep's imageRepWithData:imageRep
		set pathString to current application's NSString's stringWithString:outPath
		set newPath to pathString's stringByExpandingTildeInPath()
		set myNewImageData to (aRawimg's representationUsingType:(current application's NSPNGFileType) |properties|:(missing value))
		set aRes to (myNewImageData's writeToFile:newPath atomically:true) as boolean
		return aRes --true/false
	end saveNSImageAtPathAsPNG


	on retUUIDfilePath(aPath, aEXT)
		set aUUIDstr to (current application's NSUUID's UUID()'s UUIDString()) as string
		set aPath to ((current application's NSString's stringWithString:aPath)'s stringByAppendingPathComponent:aUUIDstr)'s stringByAppendingPathExtension:aEXT
		return aPath
	end retUUIDfilePath

end script
